## libarchive 3.6.2

=== debian/changelog ===
libarchive (3.6.2-1aatgv1) unstable; urgency=medium

  * Build for m-privacy
  * Add RSBAC settings
  * debian/rules:
    - export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
    - export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
    - export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects

 -- Amon Ott <ao@m-privacy.de>  Fri, 13 Jan 2023 10:26:36 +0100

libarchive (3.6.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database.
  * Update standards version to 4.6.0, no changes needed.

  [ Peter Pentchev ]
  * Declare compliance with Policy 4.6.2 with no changes.
  * Fix the licensing of the blake2-related files.
    Closes: #1023392
  * New upstream version:
    - fix a ZIP read vulnerability (CVE-2022-28066)
      Closes: #1008953
    - fix a memory allocation vulnerability (CVE-2022-36227)
      Closes: #1024669
    - refresh the typos patch
    - remove a lot of libarchive internal functions from the shared
      library's symbols file. These functions were never present in
      any of the public-facing libarchive header files, so they should
      not be referenced by any libarchive consumers. In version 3.6.2,
      libarchive switched to a "hide internal symbols" policy, so that
      these symbols are now not present in the shipped shared library.
    - drop the optional internal symbols regular expressions, too;
      now that libarchive hides its internal symbols, the appearance of
      any names like that in the generated symbols file would be a bug
    - add the iconv-pkgconfig patch to drop the reference to "iconv"
      from the .pc file: on Debian systems, iconv(3) is part of glibc

 -- Peter Pentchev <roam@debian.org>  Sat, 24 Dec 2022 23:17:29 +0200

=== debian/control ===
Source: libarchive
Priority: optional
Maintainer: Peter Pentchev <roam@debian.org>
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               libbz2-dev,
               liblz4-dev,
               liblzma-dev,
               libxml2-dev,
               libzstd-dev,
               zlib1g-dev,
               libacl1-dev [!hurd-any],
               libext2fs-dev,
               sharutils ,
               nettle-dev,
               locales  | locales-all 
Standards-Version: 4.6.2
Section: libs
Homepage: https://www.libarchive.org/
Vcs-Browser: https://salsa.debian.org/debian/libarchive
Vcs-Git: https://salsa.debian.org/debian/libarchive.git
Rules-Requires-Root: no

Package: libarchive-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libarchive13 (= ${binary:Version}), ${misc:Depends}
Description: Multi-format archive and compression library (development files)
 The libarchive library provides a flexible interface for reading and writing
 archives in various formats such as tar and cpio. libarchive also supports
 reading and writing archives compressed using various compression filters such
 as gzip and bzip2. The library is inherently stream-oriented; readers serially
 iterate through the archive, writers serially add things to the archive.
 .
 Archive formats supported are:
 .
    * tar (read and write, including GNU extensions)
    * pax (read and write, including GNU and star extensions)
    * cpio (read and write, including odc and newc variants)
    * iso9660 (read and write, including Joliet and Rockridge extensions, with
      some limitations)
    * zip (read only, with some limitations, uses zlib)
    * mtree (read and write)
    * shar (write only)
    * ar (read and write, including BSD and GNU/SysV variants)
    * empty (read only; in particular, note that no other format will accept an
      empty file)
    * raw (read only)
    * xar (read only)
    * rar (read only, with some limitations)
    * 7zip (read and write, with some limitations)
 .
 Filters supported are:
 .
    * gzip (read and write, uses zlib)
    * bzip2 (read and write, uses bzlib)
    * compress (read and write, uses an internal implementation)
    * uudecode (read only)
    * separate command-line compressors with fixed-signature auto-detection
    * xz and lzma (read and write using liblzma)
    * zstandard (read and write using libzstd)
 .
 This package provides the files necessary for development with libarchive.

Package: libarchive13
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: lrzip
Description: Multi-format archive and compression library (shared library)
 The libarchive library provides a flexible interface for reading and writing
 archives in various formats such as tar and cpio. libarchive also supports
 reading and writing archives compressed using various compression filters such
 as gzip and bzip2. The library is inherently stream-oriented; readers serially
 iterate through the archive, writers serially add things to the archive.
 .
 Archive formats supported are:
 .
    * tar (read and write, including GNU extensions)
    * pax (read and write, including GNU and star extensions)
    * cpio (read and write, including odc and newc variants)
    * iso9660 (read and write, including Joliet and Rockridge extensions, with
      some limitations)
    * zip (read only, with some limitations, uses zlib)
    * mtree (read and write)
    * shar (write only)
    * ar (read and write, including BSD and GNU/SysV variants)
    * empty (read only; in particular, note that no other format will accept an
      empty file)
    * raw (read only)
    * xar (read only)
    * rar (read only, with some limitations)
    * 7zip (read and write, with some limitations)
 .
 Filters supported are:
 .
    * gzip (read and write, uses zlib)
    * bzip2 (read and write, uses bzlib)
    * compress (read and write, uses an internal implementation)
    * uudecode (read only)
    * separate command-line compressors with fixed-signature auto-detection
    * xz and lzma (read and write using liblzma)
    * zstandard (read and write using libzstd)
 .
 This package provides the libarchive shared library.

Package: libarchive-tools
Architecture: any
Depends: libarchive13 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Section: utils
Description: FreeBSD implementations of 'tar' and 'cpio' and other archive tools
 This package contains several command-line tools based on the libarchive
 library.
 .
 The bsdtar program is the default system 'tar' program used on FreeBSD. bsdtar
 uses the libarchive library as a backend which does all of the work for reading
 and writing archives in various formats.
 .
 The bsdcpio program is the default system 'cpio' program used on FreeBSD.
 bsdcpio uses the libarchive library as a backend which does all of the work for
 reading and writing archives in various formats.
 .
 The bsdcat program reads archived data from files or from its standard input
 and uses the libarchive library to decompresses it to its standard output.
 It may be used for viewing the contents of archives or for passing it to other
 tools for further processing.

=== debian/rules ===
#!/usr/bin/make -f

# m-privacy
export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects

# Aim for the top, adapt if anything should break on the buildds.
DEB_BUILD_MAINT_OPTIONS=	hardening=+all
export DEB_BUILD_MAINT_OPTIONS

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --without-openssl --with-nettle \
		--enable-bsdtar=shared --enable-bsdcpio=shared \
		--enable-bsdcat=shared

override_dh_autoreconf:
	dh_autoreconf build/autogen.sh

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

execute_before_dh_install:
	find debian -name '*.la' -delete

override_dh_auto_test:
ifneq (,$(filter check,$(DEB_BUILD_OPTIONS)))
ifneq (,$(shell locale -a | grep en_US.utf8))
	_VERBOSITY_LEVEL=1 dh_auto_test --parallel
else
	mkdir -p tmp-locales
	localedef -i /usr/share/i18n/locales/en_US -c -f UTF-8 \
		-A /usr/share/locale/locale.alias tmp-locales/en_US.UTF-8
	_VERBOSITY_LEVEL=1 LOCPATH=$(CURDIR)/tmp-locales dh_auto_test --parallel
	rm -rf tmp-locales
endif
endif

execute_after_dh_installchangelogs:
	set -e; for p in $$(dh_listpackages); do \
		install -m 644 NEWS debian/$$p/usr/share/doc/$$p/; \
	done

override_dh_compress:
	mp_rsbac
	dh_compress

## libarchive 3.7.2

=== libarchive/CMakeLists.txt ===

############################################
#
# How to build libarchive
#
############################################

if (ANDROID)
  include_directories(${PROJECT_SOURCE_DIR}/contrib/android/include)
endif()

# Public headers
SET(include_HEADERS
  archive.h
  archive_entry.h
)

# Sources and private headers
SET(libarchive_SOURCES
  archive_acl.c
  archive_acl_private.h
  archive_check_magic.c
  archive_cmdline.c
  archive_cmdline_private.h
  archive_crc32.h
  archive_cryptor.c
  archive_cryptor_private.h
  archive_digest.c
  archive_digest_private.h
  archive_endian.h
  archive_entry.c
  archive_entry.h
  archive_entry_copy_stat.c
  archive_entry_link_resolver.c
  archive_entry_locale.h
  archive_entry_private.h
  archive_entry_sparse.c
  archive_entry_stat.c
  archive_entry_strmode.c
  archive_entry_xattr.c
  archive_getdate.c
  archive_getdate.h
  archive_hmac.c
  archive_hmac_private.h
  archive_match.c
  archive_openssl_evp_private.h
  archive_openssl_hmac_private.h
  archive_options.c
  archive_options_private.h
  archive_pack_dev.h
  archive_pack_dev.c
  archive_pathmatch.c
  archive_pathmatch.h
  archive_platform.h
  archive_platform_acl.h
  archive_platform_xattr.h
  archive_ppmd_private.h
  archive_ppmd8.c
  archive_ppmd8_private.h
  archive_ppmd7.c
  archive_ppmd7_private.h
  archive_private.h
  archive_random.c
  archive_random_private.h
  archive_rb.c
  archive_rb.h
  archive_read.c
  archive_read_add_passphrase.c
  archive_read_append_filter.c
  archive_read_data_into_fd.c
  archive_read_disk_entry_from_file.c
  archive_read_disk_posix.c
  archive_read_disk_private.h
  archive_read_disk_set_standard_lookup.c
  archive_read_extract.c
  archive_read_extract2.c
  archive_read_open_fd.c
  archive_read_open_file.c
  archive_read_open_filename.c
  archive_read_open_memory.c
  archive_read_private.h
  archive_read_set_format.c
  archive_read_set_options.c
  archive_read_support_filter_all.c
  archive_read_support_filter_by_code.c
  archive_read_support_filter_bzip2.c
  archive_read_support_filter_compress.c
  archive_read_support_filter_gzip.c
  archive_read_support_filter_grzip.c
  archive_read_support_filter_lrzip.c
  archive_read_support_filter_lz4.c
  archive_read_support_filter_lzop.c
  archive_read_support_filter_none.c
  archive_read_support_filter_program.c
  archive_read_support_filter_rpm.c
  archive_read_support_filter_uu.c
  archive_read_support_filter_xz.c
  archive_read_support_filter_zstd.c
  archive_read_support_format_7zip.c
  archive_read_support_format_all.c
  archive_read_support_format_ar.c
  archive_read_support_format_by_code.c
  archive_read_support_format_cab.c
  archive_read_support_format_cpio.c
  archive_read_support_format_empty.c
  archive_read_support_format_iso9660.c
  archive_read_support_format_lha.c
  archive_read_support_format_mtree.c
  archive_read_support_format_rar.c
  archive_read_support_format_rar5.c
  archive_read_support_format_raw.c
  archive_read_support_format_tar.c
  archive_read_support_format_warc.c
  archive_read_support_format_xar.c
  archive_read_support_format_zip.c
  archive_string.c
  archive_string.h
  archive_string_composition.h
  archive_string_sprintf.c
  archive_util.c
  archive_version_details.c
  archive_virtual.c
  archive_write.c
  archive_write_disk_posix.c
  archive_write_disk_private.h
  archive_write_disk_set_standard_lookup.c
  archive_write_private.h
  archive_write_open_fd.c
  archive_write_open_file.c
  archive_write_open_filename.c
  archive_write_open_memory.c
  archive_write_add_filter.c
  archive_write_add_filter_b64encode.c
  archive_write_add_filter_by_name.c
  archive_write_add_filter_bzip2.c
  archive_write_add_filter_compress.c
  archive_write_add_filter_grzip.c
  archive_write_add_filter_gzip.c
  archive_write_add_filter_lrzip.c
  archive_write_add_filter_lz4.c
  archive_write_add_filter_lzop.c
  archive_write_add_filter_none.c
  archive_write_add_filter_program.c
  archive_write_add_filter_uuencode.c
  archive_write_add_filter_xz.c
  archive_write_add_filter_zstd.c
  archive_write_set_format.c
  archive_write_set_format_7zip.c
  archive_write_set_format_ar.c
  archive_write_set_format_by_name.c
  archive_write_set_format_cpio.c
  archive_write_set_format_cpio_binary.c
  archive_write_set_format_cpio_newc.c
  archive_write_set_format_cpio_odc.c
  archive_write_set_format_filter_by_ext.c
  archive_write_set_format_gnutar.c
  archive_write_set_format_iso9660.c
  archive_write_set_format_mtree.c
  archive_write_set_format_pax.c
  archive_write_set_format_private.h
  archive_write_set_format_raw.c
  archive_write_set_format_shar.c
  archive_write_set_format_ustar.c
  archive_write_set_format_v7tar.c
  archive_write_set_format_warc.c
  archive_write_set_format_xar.c
  archive_write_set_format_zip.c
  archive_write_set_options.c
  archive_write_set_passphrase.c
  archive_xxhash.h
  filter_fork_posix.c
  filter_fork.h
  xxhash.c
)

# Man pages
SET(libarchive_MANS
  archive_entry.3
  archive_entry_acl.3
  archive_entry_linkify.3
  archive_entry_misc.3
  archive_entry_paths.3
  archive_entry_perms.3
  archive_entry_stat.3
  archive_entry_time.3
  archive_read.3
  archive_read_add_passphrase.3
  archive_read_data.3
  archive_read_disk.3
  archive_read_extract.3
  archive_read_filter.3
  archive_read_format.3
  archive_read_free.3
  archive_read_header.3
  archive_read_new.3
  archive_read_open.3
  archive_read_set_options.3
  archive_util.3
  archive_write.3
  archive_write_blocksize.3
  archive_write_data.3
  archive_write_disk.3
  archive_write_filter.3
  archive_write_finish_entry.3
  archive_write_format.3
  archive_write_free.3
  archive_write_header.3
  archive_write_new.3
  archive_write_open.3
  archive_write_set_options.3
  archive_write_set_passphrase.3
  cpio.5
  libarchive.3
  libarchive_changes.3
  libarchive_internals.3
  libarchive-formats.5
  mtree.5
  tar.5
)

IF(WIN32 AND NOT CYGWIN)
  LIST(APPEND libarchive_SOURCES archive_entry_copy_bhfi.c)
  LIST(APPEND libarchive_SOURCES archive_read_disk_windows.c)
  LIST(APPEND libarchive_SOURCES archive_windows.c)
  LIST(APPEND libarchive_SOURCES archive_windows.h)
  LIST(APPEND libarchive_SOURCES archive_write_disk_windows.c)
  LIST(APPEND libarchive_SOURCES filter_fork_windows.c)
ENDIF(WIN32 AND NOT CYGWIN)

IF(ARCHIVE_BLAKE2)
  LIST(APPEND libarchive_SOURCES archive_blake2sp_ref.c)
  LIST(APPEND libarchive_SOURCES archive_blake2s_ref.c)
ENDIF(ARCHIVE_BLAKE2)

IF(ARCHIVE_ACL_DARWIN)
  LIST(APPEND libarchive_SOURCES archive_disk_acl_darwin.c)
ELSEIF(ARCHIVE_ACL_FREEBSD)
  LIST(APPEND libarchive_SOURCES archive_disk_acl_freebsd.c)
ELSEIF(ARCHIVE_ACL_LIBACL)
  LIST(APPEND libarchive_SOURCES archive_disk_acl_linux.c)
ELSEIF(ARCHIVE_ACL_SUNOS)
  LIST(APPEND libarchive_SOURCES archive_disk_acl_sunos.c)
ENDIF()

# Libarchive is a shared library
IF(BUILD_SHARED_LIBS)
  ADD_LIBRARY(archive SHARED ${libarchive_SOURCES} ${include_HEADERS})
  TARGET_INCLUDE_DIRECTORIES(archive PUBLIC .)
  TARGET_LINK_LIBRARIES(archive ${ADDITIONAL_LIBS})
  SET_TARGET_PROPERTIES(archive PROPERTIES SOVERSION ${SOVERSION})
ENDIF(BUILD_SHARED_LIBS)

# archive_static is a static library
ADD_LIBRARY(archive_static STATIC ${libarchive_SOURCES} ${include_HEADERS})
TARGET_LINK_LIBRARIES(archive_static ${ADDITIONAL_LIBS})
SET_TARGET_PROPERTIES(archive_static PROPERTIES COMPILE_DEFINITIONS
  LIBARCHIVE_STATIC)
# On Posix systems, libarchive.so and libarchive.a can co-exist.
IF(NOT WIN32 OR CYGWIN OR NOT BUILD_SHARED_LIBS)
  SET_TARGET_PROPERTIES(archive_static PROPERTIES OUTPUT_NAME archive)
ENDIF(NOT WIN32 OR CYGWIN OR NOT BUILD_SHARED_LIBS)

IF(ENABLE_INSTALL)
  # How to install the libraries
  IF(BUILD_SHARED_LIBS)
    INSTALL(TARGETS archive
            RUNTIME DESTINATION bin
            LIBRARY DESTINATION lib
            ARCHIVE DESTINATION lib)
  ENDIF(BUILD_SHARED_LIBS)
  INSTALL(TARGETS archive_static
          RUNTIME DESTINATION bin
          LIBRARY DESTINATION lib
          ARCHIVE DESTINATION lib)
  INSTALL_MAN(${libarchive_MANS})
  INSTALL(FILES ${include_HEADERS} DESTINATION include)
ENDIF()

add_subdirectory(test)

=== doc/pdf/Makefile ===

default: all


archive_entry.3.pdf: ../../libarchive/archive_entry.3
	groff -mdoc -T ps ../../libarchive/archive_entry.3 | ps2pdf - - > archive_entry.3.pdf

archive_entry_acl.3.pdf: ../../libarchive/archive_entry_acl.3
	groff -mdoc -T ps ../../libarchive/archive_entry_acl.3 | ps2pdf - - > archive_entry_acl.3.pdf

archive_entry_linkify.3.pdf: ../../libarchive/archive_entry_linkify.3
	groff -mdoc -T ps ../../libarchive/archive_entry_linkify.3 | ps2pdf - - > archive_entry_linkify.3.pdf

archive_entry_misc.3.pdf: ../../libarchive/archive_entry_misc.3
	groff -mdoc -T ps ../../libarchive/archive_entry_misc.3 | ps2pdf - - > archive_entry_misc.3.pdf

archive_entry_paths.3.pdf: ../../libarchive/archive_entry_paths.3
	groff -mdoc -T ps ../../libarchive/archive_entry_paths.3 | ps2pdf - - > archive_entry_paths.3.pdf

archive_entry_perms.3.pdf: ../../libarchive/archive_entry_perms.3
	groff -mdoc -T ps ../../libarchive/archive_entry_perms.3 | ps2pdf - - > archive_entry_perms.3.pdf

archive_entry_stat.3.pdf: ../../libarchive/archive_entry_stat.3
	groff -mdoc -T ps ../../libarchive/archive_entry_stat.3 | ps2pdf - - > archive_entry_stat.3.pdf

archive_entry_time.3.pdf: ../../libarchive/archive_entry_time.3
	groff -mdoc -T ps ../../libarchive/archive_entry_time.3 | ps2pdf - - > archive_entry_time.3.pdf

archive_read.3.pdf: ../../libarchive/archive_read.3
	groff -mdoc -T ps ../../libarchive/archive_read.3 | ps2pdf - - > archive_read.3.pdf

archive_read_add_passphrase.3.pdf: ../../libarchive/archive_read_add_passphrase.3
	groff -mdoc -T ps ../../libarchive/archive_read_add_passphrase.3 | ps2pdf - - > archive_read_add_passphrase.3.pdf

archive_read_data.3.pdf: ../../libarchive/archive_read_data.3
	groff -mdoc -T ps ../../libarchive/archive_read_data.3 | ps2pdf - - > archive_read_data.3.pdf

archive_read_disk.3.pdf: ../../libarchive/archive_read_disk.3
	groff -mdoc -T ps ../../libarchive/archive_read_disk.3 | ps2pdf - - > archive_read_disk.3.pdf

archive_read_extract.3.pdf: ../../libarchive/archive_read_extract.3
	groff -mdoc -T ps ../../libarchive/archive_read_extract.3 | ps2pdf - - > archive_read_extract.3.pdf

archive_read_filter.3.pdf: ../../libarchive/archive_read_filter.3
	groff -mdoc -T ps ../../libarchive/archive_read_filter.3 | ps2pdf - - > archive_read_filter.3.pdf

archive_read_format.3.pdf: ../../libarchive/archive_read_format.3
	groff -mdoc -T ps ../../libarchive/archive_read_format.3 | ps2pdf - - > archive_read_format.3.pdf

archive_read_free.3.pdf: ../../libarchive/archive_read_free.3
	groff -mdoc -T ps ../../libarchive/archive_read_free.3 | ps2pdf - - > archive_read_free.3.pdf

archive_read_header.3.pdf: ../../libarchive/archive_read_header.3
	groff -mdoc -T ps ../../libarchive/archive_read_header.3 | ps2pdf - - > archive_read_header.3.pdf

archive_read_new.3.pdf: ../../libarchive/archive_read_new.3
	groff -mdoc -T ps ../../libarchive/archive_read_new.3 | ps2pdf - - > archive_read_new.3.pdf

archive_read_open.3.pdf: ../../libarchive/archive_read_open.3
	groff -mdoc -T ps ../../libarchive/archive_read_open.3 | ps2pdf - - > archive_read_open.3.pdf

archive_read_set_options.3.pdf: ../../libarchive/archive_read_set_options.3
	groff -mdoc -T ps ../../libarchive/archive_read_set_options.3 | ps2pdf - - > archive_read_set_options.3.pdf

archive_util.3.pdf: ../../libarchive/archive_util.3
	groff -mdoc -T ps ../../libarchive/archive_util.3 | ps2pdf - - > archive_util.3.pdf

archive_write.3.pdf: ../../libarchive/archive_write.3
	groff -mdoc -T ps ../../libarchive/archive_write.3 | ps2pdf - - > archive_write.3.pdf

archive_write_blocksize.3.pdf: ../../libarchive/archive_write_blocksize.3
	groff -mdoc -T ps ../../libarchive/archive_write_blocksize.3 | ps2pdf - - > archive_write_blocksize.3.pdf

archive_write_data.3.pdf: ../../libarchive/archive_write_data.3
	groff -mdoc -T ps ../../libarchive/archive_write_data.3 | ps2pdf - - > archive_write_data.3.pdf

archive_write_disk.3.pdf: ../../libarchive/archive_write_disk.3
	groff -mdoc -T ps ../../libarchive/archive_write_disk.3 | ps2pdf - - > archive_write_disk.3.pdf

archive_write_filter.3.pdf: ../../libarchive/archive_write_filter.3
	groff -mdoc -T ps ../../libarchive/archive_write_filter.3 | ps2pdf - - > archive_write_filter.3.pdf

archive_write_finish_entry.3.pdf: ../../libarchive/archive_write_finish_entry.3
	groff -mdoc -T ps ../../libarchive/archive_write_finish_entry.3 | ps2pdf - - > archive_write_finish_entry.3.pdf

archive_write_format.3.pdf: ../../libarchive/archive_write_format.3
	groff -mdoc -T ps ../../libarchive/archive_write_format.3 | ps2pdf - - > archive_write_format.3.pdf

archive_write_free.3.pdf: ../../libarchive/archive_write_free.3
	groff -mdoc -T ps ../../libarchive/archive_write_free.3 | ps2pdf - - > archive_write_free.3.pdf

archive_write_header.3.pdf: ../../libarchive/archive_write_header.3
	groff -mdoc -T ps ../../libarchive/archive_write_header.3 | ps2pdf - - > archive_write_header.3.pdf

archive_write_new.3.pdf: ../../libarchive/archive_write_new.3
	groff -mdoc -T ps ../../libarchive/archive_write_new.3 | ps2pdf - - > archive_write_new.3.pdf

archive_write_open.3.pdf: ../../libarchive/archive_write_open.3
	groff -mdoc -T ps ../../libarchive/archive_write_open.3 | ps2pdf - - > archive_write_open.3.pdf

archive_write_set_options.3.pdf: ../../libarchive/archive_write_set_options.3
	groff -mdoc -T ps ../../libarchive/archive_write_set_options.3 | ps2pdf - - > archive_write_set_options.3.pdf

archive_write_set_passphrase.3.pdf: ../../libarchive/archive_write_set_passphrase.3
	groff -mdoc -T ps ../../libarchive/archive_write_set_passphrase.3 | ps2pdf - - > archive_write_set_passphrase.3.pdf

cpio.5.pdf: ../../libarchive/cpio.5
	groff -mdoc -T ps ../../libarchive/cpio.5 | ps2pdf - - > cpio.5.pdf

libarchive.3.pdf: ../../libarchive/libarchive.3
	groff -mdoc -T ps ../../libarchive/libarchive.3 | ps2pdf - - > libarchive.3.pdf

libarchive_changes.3.pdf: ../../libarchive/libarchive_changes.3
	groff -mdoc -T ps ../../libarchive/libarchive_changes.3 | ps2pdf - - > libarchive_changes.3.pdf

libarchive-formats.5.pdf: ../../libarchive/libarchive-formats.5
	groff -mdoc -T ps ../../libarchive/libarchive-formats.5 | ps2pdf - - > libarchive-formats.5.pdf

libarchive_internals.3.pdf: ../../libarchive/libarchive_internals.3
	groff -mdoc -T ps ../../libarchive/libarchive_internals.3 | ps2pdf - - > libarchive_internals.3.pdf

mtree.5.pdf: ../../libarchive/mtree.5
	groff -mdoc -T ps ../../libarchive/mtree.5 | ps2pdf - - > mtree.5.pdf

tar.5.pdf: ../../libarchive/tar.5
	groff -mdoc -T ps ../../libarchive/tar.5 | ps2pdf - - > tar.5.pdf

bsdtar.1.pdf: ../../tar/bsdtar.1
	groff -mdoc -T ps ../../tar/bsdtar.1 | ps2pdf - - > bsdtar.1.pdf

bsdcpio.1.pdf: ../../cpio/bsdcpio.1
	groff -mdoc -T ps ../../cpio/bsdcpio.1 | ps2pdf - - > bsdcpio.1.pdf
all: archive_entry.3.pdf archive_entry_acl.3.pdf archive_entry_linkify.3.pdf archive_entry_misc.3.pdf archive_entry_paths.3.pdf archive_entry_perms.3.pdf archive_entry_stat.3.pdf archive_entry_time.3.pdf archive_read.3.pdf archive_read_add_passphrase.3.pdf archive_read_data.3.pdf archive_read_disk.3.pdf archive_read_extract.3.pdf archive_read_filter.3.pdf archive_read_format.3.pdf archive_read_free.3.pdf archive_read_header.3.pdf archive_read_new.3.pdf archive_read_open.3.pdf archive_read_set_options.3.pdf archive_util.3.pdf archive_write.3.pdf archive_write_blocksize.3.pdf archive_write_data.3.pdf archive_write_disk.3.pdf archive_write_filter.3.pdf archive_write_finish_entry.3.pdf archive_write_format.3.pdf archive_write_free.3.pdf archive_write_header.3.pdf archive_write_new.3.pdf archive_write_open.3.pdf archive_write_set_options.3.pdf archive_write_set_passphrase.3.pdf cpio.5.pdf libarchive.3.pdf libarchive_changes.3.pdf libarchive-formats.5.pdf libarchive_internals.3.pdf mtree.5.pdf tar.5.pdf bsdtar.1.pdf bsdcpio.1.pdf

=== tar/test/CMakeLists.txt ===
############################################
#
# How to build bsdtar_test
#
############################################
IF(ENABLE_TAR AND ENABLE_TEST)
  SET(bsdtar_test_SOURCES
    ../../test_utils/test_utils.c
    ../../test_utils/test_main.c
    test.h
    test_0.c
    test_basic.c
    test_copy.c
    test_empty_mtree.c
    test_extract_tar_Z.c
    test_extract_tar_bz2.c
    test_extract_tar_grz.c
    test_extract_tar_gz.c
    test_extract_tar_lrz.c
    test_extract_tar_lz.c
    test_extract_tar_lz4.c
    test_extract_tar_lzma.c
    test_extract_tar_lzo.c
    test_extract_tar_xz.c
    test_extract_tar_zstd.c
    test_format_newc.c
    test_help.c
    test_leading_slash.c
    test_missing_file.c
    test_option_C_upper.c
    test_option_C_mtree.c
    test_option_H_upper.c
    test_option_L_upper.c
    test_option_O_upper.c
    test_option_T_upper.c
    test_option_U_upper.c
    test_option_X_upper.c
    test_option_a.c
    test_option_acls.c
    test_option_b.c
    test_option_b64encode.c
    test_option_exclude.c
    test_option_exclude_vcs.c
    test_option_fflags.c
    test_option_gid_gname.c
    test_option_grzip.c
    test_option_ignore_zeros.c
    test_option_j.c
    test_option_k.c
    test_option_keep_newer_files.c
    test_option_lrzip.c
    test_option_lz4.c
    test_option_lzma.c
    test_option_lzop.c
    test_option_n.c
    test_option_newer_than.c
    test_option_nodump.c
    test_option_older_than.c
    test_option_passphrase.c
    test_option_q.c
    test_option_r.c
    test_option_s.c
    test_option_safe_writes.c
    test_option_uid_uname.c
    test_option_uuencode.c
    test_option_xattrs.c
    test_option_xz.c
    test_option_z.c
    test_option_zstd.c
    test_patterns.c
    test_print_longpath.c
    test_stdio.c
    test_strip_components.c
    test_symlink_dir.c
    test_version.c
    test_windows.c
  )

  #
  # Register target
  #
  ADD_EXECUTABLE(bsdtar_test ${bsdtar_test_SOURCES})
  IF(ENABLE_ACL)
    SET(TEST_ACL_LIBS "")
    IF(HAVE_LIBACL)
      LIST(APPEND TEST_ACL_LIBS ${ACL_LIBRARY})
    ENDIF(HAVE_LIBACL)
    IF(HAVE_LIBRICHACL)
      LIST(APPEND TEST_ACL_LIBS ${RICHACL_LIBRARY})
    ENDIF(HAVE_LIBRICHACL)
    TARGET_LINK_LIBRARIES(bsdtar_test ${TEST_ACL_LIBS})
  ENDIF(ENABLE_ACL)
  SET_PROPERTY(TARGET bsdtar_test PROPERTY COMPILE_DEFINITIONS LIST_H)

  #
  # Generate list.h by grepping DEFINE_TEST() lines out of the C sources.
  #
  GENERATE_LIST_H(${CMAKE_CURRENT_BINARY_DIR}/list.h
    ${CMAKE_CURRENT_LIST_FILE} ${bsdtar_test_SOURCES})
  SET_PROPERTY(DIRECTORY APPEND PROPERTY INCLUDE_DIRECTORIES
    ${CMAKE_CURRENT_BINARY_DIR})

  # list.h has a line DEFINE_TEST(testname) for every
  # test.  We can use that to define the tests for cmake by
  # defining a DEFINE_TEST macro and reading list.h in.
  MACRO (DEFINE_TEST _testname)
    ADD_TEST(
      NAME bsdtar_${_testname}
      COMMAND bsdtar_test -vv
                          -p $<TARGET_FILE:bsdtar>
                          -r ${CMAKE_CURRENT_SOURCE_DIR}
                          ${_testname})
  ENDMACRO (DEFINE_TEST _testname)

  INCLUDE(${CMAKE_CURRENT_BINARY_DIR}/list.h)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
  INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/test_utils)
  INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/tar/test)

  # Experimental new test handling
  ADD_CUSTOM_TARGET(run_bsdtar_test
	COMMAND	bsdtar_test -p $<TARGET_FILE:bsdtar>
			    -r ${CMAKE_CURRENT_SOURCE_DIR}
			    -vv)
  ADD_DEPENDENCIES(run_bsdtar_test bsdtar)
  ADD_DEPENDENCIES(run_all_tests run_bsdtar_test)

ENDIF(ENABLE_TAR AND ENABLE_TEST)

=== unzip/test/CMakeLists.txt ===
############################################
#
# How to build bsdunzip_test
#
############################################
IF(ENABLE_UNZIP AND ENABLE_TEST)
  SET(bsdunzip_test_SOURCES
    ../../libarchive_fe/err.c
    ../../test_utils/test_utils.c
    ../../test_utils/test_main.c
    test.h
    test_0.c
    test_basic.c
    test_glob.c
    test_singlefile.c
    test_C.c
    test_p.c
    test_d.c
    test_j.c
    test_L.c
    test_n.c
    test_o.c
    test_q.c
    test_t.c
    test_t_bad.c
    test_version.c
    test_x.c
    test_Z1.c
    test_P_encryption.c
  )

  #
  # Register target
  #
  ADD_EXECUTABLE(bsdunzip_test ${bsdunzip_test_SOURCES})
  IF(ENABLE_ACL)
    SET(TEST_ACL_LIBS "")
    IF(HAVE_LIBACL)
      LIST(APPEND TEST_ACL_LIBS ${ACL_LIBRARY})
    ENDIF(HAVE_LIBACL)
    IF(HAVE_LIBRICHACL)
      LIST(APPEND TEST_ACL_LIBS ${RICHACL_LIBRARY})
    ENDIF(HAVE_LIBRICHACL)
    TARGET_LINK_LIBRARIES(bsdunzip_test ${TEST_ACL_LIBS})
  ENDIF(ENABLE_ACL)
  SET_PROPERTY(TARGET bsdunzip_test PROPERTY COMPILE_DEFINITIONS LIST_H)

  #
  # Generate list.h by grepping DEFINE_TEST() lines out of the C sources.
  #
  GENERATE_LIST_H(${CMAKE_CURRENT_BINARY_DIR}/list.h
    ${CMAKE_CURRENT_LIST_FILE} ${bsdunzip_test_SOURCES})
  SET_PROPERTY(DIRECTORY APPEND PROPERTY INCLUDE_DIRECTORIES
    ${CMAKE_CURRENT_BINARY_DIR})

  # list.h has a line DEFINE_TEST(testname) for every
  # test.  We can use that to define the tests for cmake by
  # defining a DEFINE_TEST macro and reading list.h in.
  MACRO (DEFINE_TEST _testname)
    ADD_TEST(
      NAME bsdunzip_${_testname}
      COMMAND bsdunzip_test -vv
                           -p $<TARGET_FILE:bsdunzip>
                           -r ${CMAKE_CURRENT_SOURCE_DIR}
                           ${_testname})
  ENDMACRO (DEFINE_TEST _testname)

  INCLUDE(${CMAKE_CURRENT_BINARY_DIR}/list.h)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
  INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/test_utils)
  INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/unzip/test)

  # Experimental new test handling
  ADD_CUSTOM_TARGET(run_bsdunzip_test
	COMMAND	bsdunzip_test -p $<TARGET_FILE:bsdunzip>
			     -r ${CMAKE_CURRENT_SOURCE_DIR}
			     -vv)
  ADD_DEPENDENCIES(run_bsdunzip_test bsdunzip)
  ADD_DEPENDENCIES(run_all_tests run_bsdunzip_test)
ENDIF(ENABLE_UNZIP AND ENABLE_TEST)

=== debian/changelog ===
libarchive (3.7.2-2ubuntu0.5) noble-security; urgency=medium

  * SECURITY UPDATE: double free issue                                     
    - debian/patches/CVE-2025-5914.patch: rar: Fix double free with over   
      4 billion nodes                                                      
    - CVE-2025-5914                                                        
  * SECURITY UPDATE: heap-based buffer overflow                            
    - debian/patches/CVE-2025-5915.patch: rar: Fix heap-buffer-overflow    
    - CVE-2025-5915                                                        
  * SECURITY UPDATE: integer overflow                                      
    - debian/patches/CVE-2025-5916.patch: warc: Prevent signed integer     
      overflow                                                             
    - CVE-2025-5916                                                        
  * SECURITY UPDATE: out-of-bound write overflow                           
    - debian/patches/CVE-2025-5917.patch: Fix overflow in build_ustar_entry
    - CVE-2025-5917

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 25 Jun 2025 15:20:27 +0530

libarchive (3.7.2-2ubuntu0.4) noble-security; urgency=medium

  * SECURITY UPDATE: DoS via null pointer deref
    - debian/patches/CVE-2025-1632_25724.patch: check return code of
      archive_entry_pathname() in unzip/bsdunzip.c.
    - CVE-2025-1632
  * SECURITY UPDATE: DoS via crafted TAR archive
    - debian/patches/CVE-2025-1632_25724.patch: make sure ltime is valid in
      tar/util.c.
    - CVE-2025-25724

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 10 Apr 2025 13:28:58 -0400

libarchive (3.7.2-2ubuntu0.3) noble-security; urgency=medium

  * SECURITY UPDATE: code execution via negative copy length
    - debian/patches/CVE-2024-20696.patch: protect
      copy_from_lzss_window_to_unp() in
      libarchive/archive_read_support_format_rar.c.
    - CVE-2024-20696

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 29 Oct 2024 10:02:44 +0100

libarchive (3.7.2-2ubuntu0.2) noble-security; urgency=medium

  * SECURITY UPDATE: Out of bounds access
    - debian/patches/CVE-2024-48957.patch: check dst isn't less than or
      equal to src in execute_filter_audio
    - CVE-2024-48957
  * SECURITY UPDATE: Out of bounds access
    - debian/patches/CVE-2024-48958.patch: check dst isn't less than or
      equal to src in execute_filter_delta
    - CVE-2024-48958

 -- Bruce Cable <bruce.cable@canonical.com>  Mon, 14 Oct 2024 12:12:50 +1100

libarchive (3.7.2-2ubuntu0.1) noble-security; urgency=medium

  * SECURITY UPDATE: Remove code execution
    - debian/patches/CVE-2024-26256.patch: fix OOB in rar e8 filter
      in libarchive/archive_read_support_format_rar.c.
    - CVE-2024-26256

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 30 May 2024 11:57:56 -0300

libarchive (3.7.2-2) unstable; urgency=medium

  [ Luca Boccassi ]
  * libarchive-dev: depend on -dev packages in an attempt to
    fix pkg-config --static --libs
    Addresses: 1056317; more work needed on libarchive's own
    configure tests

  [ Peter Pentchev ]
  * Acknowledge Lukas Märdian 64-bit-time_t-related NMU. Thanks!
  * Add the year 2024 to my debian/* copyright notice.
  * Re-sort the dependencies lists in the debian/control file.
  * Switch the pkg-config dependency over to pkgconf.
  * Add the robust-error-reporting upstream patch. Closes: #1068047

 -- Peter Pentchev <roam@debian.org>  Sat, 30 Mar 2024 20:11:06 +0200

libarchive (3.7.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062224

 -- Lukas Märdian <slyon@debian.org>  Thu, 29 Feb 2024 08:40:57 +0000

libarchive (3.7.2-1) unstable; urgency=medium

  * Add the iso9660-hash patch to fix file ordering. Closes: #1051322
  * Add the year 2023 to my debian/* copyright notice.
  * Declare compatibility with version 1 of the dpkg build API:
    - drop the implied Rules-Requires-Root declaration
    - include dpkg's default.mk file for completeness
  * Use dh-package-notes to record ELF package metadata.
  * New upstream version:
    - build and install the new bsdunzip tool in libarchive-tools
    - drop the iconv-pkgconfig patch, applied upstream
    - update the upstream copyright information
  * Do not detect -amd64 versions in the watch file.
  * Add the test-zstd-32bit upstream patch.

 -- Peter Pentchev <roam@debian.org>  Sat, 14 Oct 2023 18:28:55 +0300

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,12 @@
 Source: libarchive
 Priority: optional
-Maintainer: Peter Pentchev <roam@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Peter Pentchev <roam@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               pkg-config,
+               dpkg-build-api (= 1),
+               dpkg-dev (>= 1.22.5),
+               dh-package-notes,
+               pkgconf,
                libbz2-dev,
                liblz4-dev,
                liblzma-dev,
@@ -11,21 +15,30 @@
                zlib1g-dev,
                libacl1-dev [!hurd-any],
                libext2fs-dev,
-               sharutils ,
+               sharutils <!nocheck>,
                nettle-dev,
-               locales  | locales-all 
+               locales <!nocheck> | locales-all <!nocheck>
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://www.libarchive.org/
 Vcs-Browser: https://salsa.debian.org/debian/libarchive
 Vcs-Git: https://salsa.debian.org/debian/libarchive.git
-Rules-Requires-Root: no
 
 Package: libarchive-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libarchive13 (= ${binary:Version}), ${misc:Depends}
+Depends: libarchive13t64 (= ${binary:Version}),
+         libbz2-dev,
+         liblz4-dev,
+         liblzma-dev,
+         libxml2-dev,
+         libzstd-dev,
+         zlib1g-dev,
+         libacl1-dev [!hurd-any],
+         libext2fs-dev,
+         nettle-dev,
+         ${misc:Depends},
 Description: Multi-format archive and compression library (development files)
  The libarchive library provides a flexible interface for reading and writing
  archives in various formats such as tar and cpio. libarchive also supports
@@ -63,7 +76,10 @@
  .
  This package provides the files necessary for development with libarchive.
 
-Package: libarchive13
+Package: libarchive13t64
+Provides: ${t64:Provides}
+Replaces: libarchive13
+Breaks: libarchive13 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -107,7 +123,7 @@
 
 Package: libarchive-tools
 Architecture: any
-Depends: libarchive13 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libarchive13t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Section: utils
 Description: FreeBSD implementations of 'tar' and 'cpio' and other archive tools
  This package contains several command-line tools based on the libarchive

=== debian/watch ===
version=4
opts=dversionmangle=s/[-.+~]?(cvs|svn|git|snapshot|pre|hg|repack)(.*)$//i,\
     pgpsigurlmangle=s/$/.asc/ \
https://www.libarchive.org/downloads/ ./libarchive-(\d[\d.]+)@ARCHIVE_EXT@
